<?php
/**
 * comments_controller.php
 *
 * A very basic Comments controller
 *
 * @copyright Dr. Tarique Sani, tarique@sanisoft.com
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License V2
 * @package cheeseCake
 * @version $id$
 */
class CommentsController extends AppController
{
	var $name = 'Comments';
    var $helpers = array('Html','Javascript','Cheese','Pagination');
    var $Sanitize = '';
    var $rdAccess = array('delete' => array('Admin'),
                          'edit' => array('Admin')
                         );
	var $components = array('Pagination','rss');

	function add($foreignKey=null)
	{
		if (!empty($this->params['data']['Comment']) && $foreignKey <> null ){
		       $this->params['data']['Comment']['id'] = '';
		       $this->params['data']['Comment']['photo_id'] = (int)$foreignKey;
		       $this->Sanitize = new Sanitize;
			   $this->Sanitize->cleanArray($this->params['data']); //Hopefully this is enough
                       if ($this->Comment->save($this->params['data'])){
                            $this->Session->setFlash('Your comment was saved successfully');
                            $this->redirect('/view/'.(int)$foreignKey);
                       }else{
                            $this->Session->setFlash('Your comment could not be saved');
                            $this->set('id',$foreignKey);
                       }
		}else {
			$this->redirect('/');
		}
	}

	function index()
	{                
                $paging['sortBy']='created';
		$paging['direction']='DESC';
                list($order,$limit,$page) = $this->Pagination->init(null,$paging);
                $comments = $this->Comment->findAll(null,"", $order, $limit, $page);
		if(!empty($comments)){
			$this->set('comments', $comments);
			$this->pageTitle = $this->siteName.' - Browse Comments';
		}else{
			$this->pageTitle = $this->siteName.' - No Comments';
			$this->set('message',"No comments were found, add some...");
			$this->render(null,null,'views/errors/cc_die.thtml');
		}

	}

	function edit($id=null,$from=null)
	{
	if (empty($this->data) && $id <> null)
            {
                $this->Comment->id = $id;
                $this->data = $this->Comment->read();
                $this->set('id',$id);

            }
            else
            {
                if ($this->Comment->save($this->data))
                {
                   $this->Session->setFlash('The comment has been updated successfully');
                   $from?$this->redirect('comments'):$this->redirect('/view/'.$this->data['Photo']['id']);
                }
            }

	}

	function delete($id,$from)
	{
		if($this->Comment->del($id)){
			$this->Session->setFlash('The comment has been deleted successfully');
		}else{
			$this->Session->setFlash('The comment could not be deleted');
		}
		$from=='index'?$this->redirect('comments'):$this->redirect('/view/'.(int)$from);
	}
}
?>